<?php
/*------------------------------------------------------------------------------
	Newspage example with PHP and XML
	written by Christian Heilmann (info@onlinetools.org)
	to accompany the article on www.alistapart.com about easy PHP and XML
------------------------------------------------------------------------------*/
$page="archive";
$itemcount=3; //(how many "new" news to display)

// Load XML data and HTML
$xml=load("news.xml");
$template=load("newstemplate.html");

// Extract HTML snippet for news item
preg_match("/<!-- start:newsitem -->(.*?)<!-- end:newsitem -->/si",$template,$newshtml);

// Gather data from XML file
// gat all news items
$items=untag($xml,"item",1);

// reverse news items -> latest displayed first
$items=array_reverse($items);

/*---------------------- no search initiated ---------------------------------*/
if (!$q){ 
	if ($page=="archive"){	
		// if the page is the archive
		// display archive intro text
		// start at item itemcount and display all following
		$template=preg_replace("/<!-- start:newsintro -->(.*?)<!-- end:newsintro -->/si","",$template);
		$start=$itemcount;	
		$end=sizeof($items);

	}else{ 					
		// if the page is the news page
		// display news intro text
		// start at 0 and display until itemcount is reached
		$template=preg_replace("/<!-- start:archiveintro -->(.*?)<!-- end:archiveintro -->/si","",$template);
		$start=0; 
		$end=$itemcount;
	}

	// assemble news HTML
	for ($f=$start;$f<$end;$f++){
			$i=$items[$f]; 
			// get <item> data
			// take HTML template raw data and replace the variables with the
			// XML data and add each item to HTML include part
			$tmphtml=$newshtml[0];
			$tmphtml=str_replace("<!-- date -->",untag($i,"date",0),$tmphtml);
			$tmphtml=str_replace("<!-- headline -->",untag($i,"headline",0),$tmphtml);
			$tmphtml=str_replace("<!-- copy -->",untag($i,"copy",0),$tmphtml);
			$newsinclude.=$tmphtml; 
	}

	// delete search result messages
	$template=preg_replace("/<!-- start:noitemfound -->(.*?)<!-- end:noitemfound -->/si","",$template);
	$template=preg_replace("/<!-- start:itemfound -->(.*?)<!-- end:itemfound -->/si","",$template);

	// if the page is the archive delete link to archive
	// else delete link to news
	if ($page=="archive"){	
		$template=preg_replace("/<!-- start:linkarchive -->(.*?)<!-- end:linkarchive -->/si","",$template);
	}else{ 	
		$template=preg_replace("/<!-- start:linknews -->(.*?)<!-- end:linknews -->/si","",$template);
	}

// If there was a search initiated...
}else{
	// preset no item found
	$found=0;
	// loop over items
	foreach ($items as $i){
		// compare the item data with search query and populate HTML include 
		// if there were matching items found 
		if (preg_match("/".$q."/si",$i)){		
			$tmphtml=$newshtml[0];
			$tmphtml=str_replace("<!-- date -->",untag($i,"date",0),$tmphtml);
			$tmphtml=str_replace("<!-- headline -->",untag($i,"headline",0),$tmphtml);
			$tmphtml=str_replace("<!-- copy -->",untag($i,"copy",0),$tmphtml);
			$newsinclude.=$tmphtml;
			// increase number of found items
			$found++;
		}
	}
	// if there was an item found, delete no item found message
	// or vice versa
	if ($found!=0){
		$template=preg_replace("/<!-- start:noitemfound -->(.*?)<!-- end:noitemfound -->/si","",$template);
	}else{
		$template=preg_replace("/<!-- start:itemfound -->(.*?)<!-- end:itemfound -->/si","",$template);
	}
	// delete intro text
	$template=preg_replace("/<!-- introtext -->/si","",$template);
}

// Replace News items with HTML include data, delete all other quotes, delete
// empty lines and display page
$template=preg_replace("/<!-- start:newsitem -->(.*?)<!-- end:newsitem -->/si",$newsinclude,$template);
$template=preg_replace("/<!--(.*?)-->/si","",$template);
$template=preg_replace("/\n\r/si","",$template);
echo $template;
// In case you want to generate a flat news HTML file, just uncomment this line,
// and make sure that the attribute settings of the folder are correct, to allow
// this script to generate this new file.
# save("news.html",$template);

/*----------------------- Reused functions -----------------------------------*/

/*
	Function save($file,$content)
	writes the content to the file and generates it if needed
*/
function save($filelocation,$newdatas){
	$newfile = fopen($filelocation,"w+");
	fwrite($newfile, $newdatas);
	fclose($newfile);
	}
	
/*
	Function load($file)
	reads the content of the file that you send and returns it
*/
function load($filelocation){
	if (file_exists($filelocation)){
		$newfile = fopen($filelocation,"r");
		$file_content = fread($newfile, filesize($filelocation));
		fclose($newfile);
		return $file_content;
		}
	}

/*
	Function untag($string,$tag,mode){
	written by Chris Heilmann (info@onlinetools.org)
	filters the content of tag $tag from $string 
	when mode is 1 the content gets returned as an array
	otherwise as a string
*/
function untag($string,$tag,$mode){
	$tmpval="";
	$preg="/<".$tag.">(.*?)<\/".$tag.">/si";
	preg_match_all($preg,$string,$tags); 
	foreach ($tags[1] as $tmpcont){
		if ($mode==1){$tmpval[]=$tmpcont;}
		else {$tmpval.=$tmpcont;}
		}
	return $tmpval;
}	
?>

